
const rnd_sen = require("nv-random-sentence");
const rnd_j   = require('nv-random-json').rand;
const rnd_n   = require('nv-random-number');

const {is_ary} = require("nv-facutil-basic");

const at_same_time = async (eng,eng_cls_name,dbname,tbl,count)=> {
    const DB = require(eng)[eng_cls_name];
    let db = new DB(dbname);
    await db.conn();
    let dflt_desc = await db.get_dflt_desc(tbl);
    let DATA_KS   = dflt_desc.DATA_KS
    let DATA_ALIAS_KS = dflt_desc.DATA_ALIAS_KS;
    let DATA_TYPS = dflt_desc.DATA_TYPS
    for(let i=0;i<count;i++) {
         let data = {} 
         for(let j=0;j<DATA_KS.length;j++) {
              let k = DATA_ALIAS_KS[j];
              let t = DATA_TYPS[j];
              if(t === 'text')  {
                  data[k] = rnd_sen.NVN_; 
              } else if(t === 'jsonb') {
                  data[k] = rnd_j(5,10);
                  if(is_ary(data[k])) {
                      data[k] = ["#ary",data[k]]
                  }
              } else if(
                    t === 'integer'
              ) {
                  data[k] = rnd_n.int32(0,2**32-1)
              } else if(
                    t === 'bigint' 
              ) {
                  data[k] = rnd_n.bigint(0n,2n**63n-1n)
              } else {
              }
         } 
         let r = await db.insert_one({tbl,data})
    }
}


module.exports = {
    at_same_time
}


